import time
import os

class Picker:

    directory = None
    dispatcher = None
    observer = None
    last_file_time = None

    def __init__(self, directory, dispatcher):
        self.directory = directory
        self.dispatcher = dispatcher

    def identify_time_window(self, file_time):
        if self.last_file_time is None:
            self.last_file_time = time.time()
        if file_time > self.last_file_time:
            return True
        return False

    def list_files(self):
        files = []
        for filename in os.listdir(self.directory):
            filepath = os.path.join(self.directory, filename)
            if os.path.isfile(filepath):
                files.append(filepath)
        return files


    def observe(self):
        while True:
            files = self.list_files()
            for file in files:
                file_time = os.path.getmtime(file)
                if self.identify_time_window(file_time):
                    self.dispatcher.process_audio_file(file)
            self.last_file_time = time.time()
            time.sleep(10)
